/* File: picodb.h */

#ifndef PICODB_H
#define	PICODB_H


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <sys/ptrace.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/reg.h>
#include <sys/syscall.h>
#include <sys/shm.h>
#include <sys/stat.h>
#include <unistd.h>


/*defined metavlites gia to read kai write ton pipes*/
#define READ 0
#define WRITE 1

/*to pid tou parakolouthoumenou ektelesimou*/
pid_t tr_exe_pid;
/*metavlites gia ta arxeia pou tha xrisimopoiithoun*/
FILE *fin, *fout, *ferr;
/*to sigaction gia ton handler simaton*/
static struct sigaction act;

/*domi pou periexei ta pids ton diergasion gia tis anakateuthinseis*/
typedef struct streams_pids
{
    pid_t stdin_pid;
    pid_t stdout_pid;
    pid_t stderr_pid;
}streams_pids;
/*to anagnoristiko gia tin koini mnimi*/
int shmseg_id;
/*deiktis stin koini mnimi*/
streams_pids *spids;

/*synartisi gia tin diaxeirisi ton simaton*/
void interrupt_handler(int signo);
/*ektyposi enos minimatos kalosorismatos*/
void print_welcome();
/*ektyposi -> gia na deiksei sto xristi anamoni eisodou*/
void print_wait_input();
/*ektyposi minimatos sfalmatos */
void print_wrong_command();
/*ektyposi diathesimon entolon kai perigrafis tous*/
void print_help();
/*orismos ton metavliton katallila gia tin entoli trace*/
void trace_command(char *input, char *temp, int *tr_cat_pc, int *tr_cat_fm);
/*orismos ton metavliton katallila gia tin entoli redirect*/
void redirect_command(char *input, char *temp, 
                      int *rd_stdin, int *rd_stdout, int *rd_stderr,
                      char *rd_infile, char *rd_outfile, char *rd_errfile);
/*orismos ton metavliton katallila gia tin entoli block*/
void block_command(char *input, char *temp, int *blk_mode);
/*orismos ton metavliton katallila gia tin entoli limit*/
void limit_command(char *input, char *temp, int *lmt_trace, int *lmt_number);
/*elengxos an oi klisi systimatos pou irthe anikei se mia apo tis katigories tou file-management
  kai ektyposi katallilou minimatos an den exei kseperastei to limit se eriptosi pou einai energopoiimeno. 
  Epistrefei 1 an se blocking mode o xristis den epithimei na synexisei allios 0*/
int go_fm_categories(int orig_eax, int lmt_trace, int lmt_number, int blk_mode, pid_t pid,  
                      int *tcfm_tmp, int *insyscall, int *cur_num_fm);
/*elengxos an oi klisi systimatos pou irthe anikei se mia apo tis katigories tou process-control
  kai ektyposi katallilou minimatos an den exei kseperastei to limit se eriptosi pou einai energopoiimeno. 
  Epistrefei 1 an se blocking mode o xristis den epithimei na synexisei allios 0*/
int go_pc_categories(int orig_eax, int lmt_trace, int lmt_number, int blk_mode, pid_t pid,  
                      int *tcpc_tmp, int *insyscall, int *cur_num_pc, int *calls);
/*pernaei ston pinaka tou deuterou orismatos ta orismata pou dothikan stin go + oti xreiazetai gia tin execv*/
void go_get_args(char* input, char* tr_exe_args[], char* tr_exe);
/*ektyposi minimatos ston xristi an thelei na synexisei, elengos orthotitas eisodou kai epistrofi
  1 an thelei na stamatisei kai 0 an thelei na synexisei*/
int block(int blk_mode);
/*arxikopoiisi koinis mnimis*/
void init_shmemseg();
/*apokolisi tis koinis mnimis*/
void det_shmemseg();
/*diagrafi tis koinis mnimis*/
void rm_shmemseg();


#endif	/* PICODB_H */
