/* File: picodb.c */


#include "functions.h"


int main(int argc, char* argv[])
{
    /*orismos tou action pou tha kaleitai otan erthei ena apo ta parakato simata*/
    act.sa_handler = interrupt_handler;
    sigfillset(&(act.sa_mask));
    sigaction(SIGINT, &act , NULL); 
    sigaction(SIGTERM, &act , NULL); 
    sigaction(SIGHUP, &act , NULL); 
    
    char *tr_exe, input[50], temp[30], rd_infile[30], rd_outfile[30], rd_errfile[30];
    int tr_cat_pc = 0, tr_cat_fm = 0, rd_stdin = 0, rd_stdout = 0, rd_stderr = 0, blk_mode = 0, lmt_trace = 0, lmt_number;   
    
    /*elengxos tou arithmou ton arguments*/
    if (argc < 2)
    {
        printf("Not enough arguments! The program will now exit...\n");
        return 0;
    }           
    
    /*perasma tou  onomatos tou ektelesimou apo orisma se metavliti*/
    tr_exe = argv[1];  
    
    init_shmemseg();
    
    print_welcome();
    print_wait_input();    
    
    fgets(input, 100, stdin);    
    if(sscanf(input, "%s", temp) == EOF)
    {
        strcpy(temp, "");
    }
    /*oso den dothei apo ton xristi i entoli gia termatismo*/
    while(strcmp(temp, "q") && strcmp(temp, "quit"))
    {   
        /*analoga me tin entoli pou dothike apo ton xristi mpainei sto anistoixo if*/
        if(!strcmp(temp, "t") || !strcmp(temp, "trace"))
        {
            trace_command(input, temp, &tr_cat_pc, &tr_cat_fm);
        }
        else if(!strcmp(temp, "r") || !strcmp(temp, "redirect"))
        {
            redirect_command(input, temp, &rd_stdin, &rd_stdout, &rd_stderr,
                             rd_infile, rd_outfile, rd_errfile);
        }
        else if(!strcmp(temp, "b") || !strcmp(temp, "blocking-mode"))
        {
            block_command(input, temp, &blk_mode);
        }        
        else if(!strcmp(temp, "l") || !strcmp(temp, "limit-trace"))
        {
            limit_command(input, temp, &lmt_trace, &lmt_number); 
        }       
        else if(!strcmp(temp, "g") || !strcmp(temp, "go"))
        {      
            pid_t tr_tempid, stdin_tempid, stdout_tempid, stderr_tempid;
            long orig_eax; 
            int status, insyscall = 0, cur_num_fm = 0, cur_num_pc = 0, tcpc_tmp = tr_cat_pc, tcfm_tmp = tr_cat_fm;    
            char *tr_exe_args[20];              
            
            go_get_args(input, tr_exe_args, tr_exe);
                      
            tr_tempid = fork();
            if(tr_tempid == -1)
            {
                perror("Failed to fork!");
                return 1;
            }
            /*an einai to paidi pou tha trexei to programma*/
            else if(tr_tempid == 0) 
            {
                /*an einai energopoiimeni i anakateuthinsi stdin apo arxeio*/
                if(rd_stdin)
                {
                    int fd[2];

                    if (pipe(fd) == -1)
                    {
                        perror("Failed to create pipe!");
                        exit(1);
                    }
                    
                    stdin_tempid = fork();
                    if(stdin_tempid == -1)
                    {
                        perror("Failed to fork!");
                        exit(1);                        
                    }
                    else if(stdin_tempid == 0)
                    {
                        close(fd[READ]);
                        dup2(fd[WRITE], STDOUT_FILENO);
                        close(fd[WRITE]);
                        
                        fin = fopen(rd_infile, "r");
                        char buffer[1024];

                        fgets(buffer, 1024, fin);
                        while(!feof(fin))
                        {                              
                            printf("%s", buffer);
                            fgets(buffer, 1024, fin);
                        }
                        
                        fclose(fin);
                        fin = NULL;
                        det_shmemseg();
                        exit(0);                        
                    }
                    else
                    {
                        spids->stdin_pid = stdin_tempid;
                        
                        close(fd[WRITE]);
                        dup2(fd[READ], STDIN_FILENO);
                        close(fd[READ]);
                    }
                }
                /*an einai energopoiimeni i anakateuthinsi stdout se arxeio*/
                if(rd_stdout)
                {
                    int fd[2];

                    if (pipe(fd) == -1)
                    {
                        perror("Failed to create pipe!");
                        exit(1);
                    }                                       
                    
                    stdout_tempid = fork();
                    if(stdout_tempid == -1)
                    {
                        perror("Failed to fork!");
                        exit(1);                         
                    }
                    else if(stdout_tempid == 0)
                    {                                               
                        close(fd[WRITE]);
                        dup2(fd[READ], STDIN_FILENO);
                        close(fd[READ]);

                        fout = fopen(rd_outfile, "w");
                        char buffer[1024];

                        while(fread(buffer, 1, 1024, stdin) != 0)
                        {  
                            fprintf(fout, "%s", buffer);
                        }
                        
                        fclose(fout);
                        fout = NULL;
                        det_shmemseg();
                        exit(0);
                    }
                    else
                    {
                        spids->stdout_pid = stdout_tempid;
                        
                        close(fd[READ]);
                        dup2(fd[WRITE], STDOUT_FILENO);
                        close(fd[WRITE]);                         
                        
                    }
                }
                /*an einai energopoiimeni i anakateuthinsi stderr se arxeio*/
                if(rd_stderr)
                {
                    int fd[2];

                    if (pipe(fd) == -1)
                    {
                        perror("Failed to create pipe!");
                        exit(1);
                    }
                    
                    stderr_tempid = fork();
                    if(stderr_tempid == -1)
                    {
                        perror("Failed to fork!");
                        exit(1);                         
                    }
                    else if(stderr_tempid == 0)
                    {
                        close(fd[WRITE]);
                        dup2(fd[READ], STDIN_FILENO);
                        close(fd[READ]); 
                        
                        ferr = fopen(rd_errfile, "w");
                        char buffer[1024];

                        while(fread(buffer, 1, 1024, stdin) != 0)
                        {  
                            fprintf(ferr, "%s", buffer);
                        }
                        
                        fclose(ferr);
                        ferr = NULL;
                        det_shmemseg();
                        exit(0);                        
                    }
                    else
                    {
                        spids->stderr_pid = stderr_tempid;
                        
                        close(fd[READ]);
                        dup2(fd[WRITE], STDERR_FILENO);
                        close(fd[WRITE]);                         
                    }
                }
                
                det_shmemseg();
                ptrace(PTRACE_TRACEME, 0, NULL, NULL);
                /*ksekinaei to ektelesimo pou dothike os orisma na ekteleitai*/
                execv(tr_exe, tr_exe_args);
            }
            /*an einai o pateras diladi to picodb*/
            else 
            {
                tr_exe_pid = tr_tempid;
                int calls = 1;
                while(1) 
                {
                    wait(&status);
                    /*an to parakolouthoumeno programma teleiosei kanonika
                      i diakopei apo kapoio sima stamataei i parakolouthisi*/
                    if (WIFEXITED(status) || WIFSIGNALED(status))
                        break;

                    orig_eax = ptrace(PTRACE_PEEKUSER, tr_exe_pid, 4 * ORIG_EAX, NULL);
                    
                    /*an einai energopoimeni i parakolouthisi kliseon katigorias process-control*/
                    if(tcpc_tmp)
                    {
                        if(go_pc_categories(orig_eax, lmt_trace, lmt_number, blk_mode, tr_exe_pid,  
                                         &tcpc_tmp, &insyscall, &cur_num_pc, &calls))
                        {
                            break;
                        }                           
                    }
                    /*an einai energopoimeni i parakolouthisi kliseon katigorias file-management*/
                    if (tcfm_tmp)
                    {
                        if (go_fm_categories(orig_eax, lmt_trace, lmt_number, blk_mode, tr_exe_pid,  
                                         &tcfm_tmp, &insyscall, &cur_num_fm))
                        {
                            break;
                        }
                    }
                    
                    /*an sto ektelesimo irthe sima kai exei termatisei den mpainei*/
                    if(tr_exe_pid != 0)
                    {            
                        ptrace(PTRACE_SYSCALL, tr_exe_pid, NULL, NULL);
                    }
                }
            }
            
            printf("\nThe traced process has finished running with the following options:\n"
                    "Trace category: %s\n"
                    "Redirect of the stdin: %s\n"
                    "Redirect of the stdout: %s\n"
                    "Redirect of the stderr: %s\n"
                    "Blocking mode: %s\n"
                    "Limit trace: %d%s",
                    tr_cat_fm && tr_cat_pc ? "all" : (!tr_cat_fm && !tr_cat_pc ? "none" : 
                    (tr_cat_fm ? "file-management" : "process-control")), 
                    rd_stdin ? rd_infile : "none", rd_stdout ? rd_outfile : "none", rd_stderr ? rd_errfile : "none",
                    blk_mode ? "on" : "off", lmt_trace ? lmt_number : 0, blk_mode ? "\n" : "\n->");                        
            
            /*arxikopoiisi ton pids gia epomeni ektelesi*/
            tr_exe_pid = 0;
            spids->stdin_pid = 0, spids->stdout_pid = 0, spids->stderr_pid = 0; 
        }    
        else if(!strcmp(temp, "h") || !strcmp(temp, "help"))
        {                      
            print_help();
            print_wait_input();            
        }      
        else if(!strcmp(temp, ""))
        {
            print_wait_input();
        }          
        else
        {
            print_wrong_command();
            print_wait_input();
        }
        
        fgets(input, 100, stdin);        
        if(sscanf(input, "%s", temp) == EOF)
        {
            strcpy(temp, "");
        }
    }
    
    printf("\nGoodbye!\n");
    
    det_shmemseg();
    rm_shmemseg();
    
    return 0;
}
